PS(1)

NAME
ps - display process status

SYNOPSIS
ps [-aCcehjkLlmrSTuvwx] [-M core] [-N system] [-O fmt] [-o fmt] [-p pid] [-t tty] [-U username] [-W swap]

DESCRIPTION
The ps utility displays information about active processes. When given no options, ps prints information about processes of the current user that have a controlling terminal.

The information displayed is selected based on a set of keywords (and for even more control, see the -L, -O, and -o options). The default output format includes, for each process, the process's ID, controlling terminal, CPU time (including both user and system time), state, and associated command.

The options are as follows:

-a  Display information about other users' processes as well as your own.

-C  Change the way the CPU percentage is calculated by using a “raw” CPU calculation that ignores “resident” time (this normally has no effect).

-c  Do not display full command with arguments, but only the executable name. This may be somewhat confusing; for example, all sh(1) scripts will show as “sh”.

-e  Display the environment as well.

-h  Repeat the information header as often as necessary to guarantee one header per page of information.

-j  Print information associated with the following keywords: user, pid, ppid, pgid, sess, jobc, state, tt, time, and command.

-k  Also display information about kernel threads.

-L  List the set of available keywords. This option should not be specified with other options.

-l  Display information associated with the following keywords: uid, pid, ppid, cpu, pri, nice, vsz, rss, wchan, state, tt, time, and command.

-M core
    Extract values associated with the name list from the specified core instead of the running kernel.

-m  Sort by memory usage, instead of by start time ID.

-N system
    Extract the name list from the specified system instead of the running kernel.

-O fmt
    Add the information associated with the space or comma separated list of keywords specified, after the process ID, in the default information display. Keywords may be appended with an equals sign (‘=’) and a string. This causes the printed header to use the specified string instead of the standard header.

-o fmt
    Display information associated with the space or comma separated list of keywords specified. Keywords may be appended with an equals sign (‘=’) and a string. This causes the printed header to use the specified string instead of the standard header.

-p pid
    Display information associated with the specified process ID.

-r  Sort by current CPU usage, instead of by start time ID.

-S  Change the way the process time is calculated by summing all exited children to their parent process.

-T  Display information about processes attached to the device associated with the standard input.

-t tty
    Display information about processes attached to the specified terminal device.

-U username
    Display the processes belonging to the specified username.

-u  Display information associated with the following keywords: user, pid, %cpu, %mem, vsz, rss, tt, state, start, time, and command. The -u option implies the -r option.

-v  Display information associated with the following keywords: pid, state, time, sl, re, pagein, vsz, rss, lim, tsiz, %cpu, %mem, and command. The -v option implies the -m option.

-W swap
    When not using the running kernel, extract swap information from the specified file.

-w  Use 132 columns to display information, instead of the default, which is the window size. If the -w option is specified more than once, ps will use as many columns as necessary without regard for window size.

-x  Display information about processes without controlling terminals.

KEYWORDS
The following is a complete list of the available keywords and their meanings. Several of them have aliases, which are also noted.

%cpu
    Alias: pcpu. The CPU utilization of the process; this is a decaying average over up to a minute of previous (real) time. Since the time base over which this is computed varies (since processes may be very young) it is possible for the sum of all %cpu fields to exceed 100%.

%mem
    Alias: pmem. The percentage of real memory used by this process.

acflag
    Alias: acflg. Accounting flag.

command
    Alias: args. Command and arguments.

cpu Short-term CPU usage factor (for scheduling).

cpuid
    CPU ID (zero on single processor systems).

dsiz
    Data size, in Kilobytes.

emul
    Name of system call emulation environment.

flags
    Alias: f. The union of the flags (in hexadecimal) associated with the process and the thread as in the include file <sys/proc.h>:

        PS_CONTROLT       0x2 process has a controlling terminal
        P_SIGSUSPEND      0x8 need to restore before-suspend mask
        PS_PPWAIT        0x10 parent is waiting for child to
        		      exec/exit
        P_PROFIL         0x20 process has started profiling
        P_SELECT         0x40 selecting; wakeup/waiting danger
        P_SINTR          0x80 sleep is interruptible
        PS_SUGID        0x100 process had set ID privileges since
        		      last exec
        P_SYSTEM        0x200 system process: no sigs, stats, or
        		      swapping
        P_TIMEOUT       0x400 timing out during sleep
        P_TRACED        0x800 process is being traced
        P_WAITED       0x1000 debugging process has waited for
        		      child
        P_WEXIT        0x2000 working on exiting
        PS_EXEC        0x4000 process called exec(3)
        P_OWEUPC       0x8000 owe process an addupc() call at next
        		      ast
        PS_ISPWAIT    0x10000 is parent of PPWAIT child
        P_SSTEP       0x20000 process needs single-step fixup
        PS_SUGIDEXEC  0x40000 last exec(3) was set[ug]id
        P_NOZOMBIE   0x100000 pid 1 waits for me instead of dad
        P_INEXEC     0x200000 process is doing an exec right now
        P_SYSTRACE   0x400000 process system call tracing is active
        P_THREAD    0x4000000 only a thread, not a real process
        P_IGNEXITRV 0x8000000 for thread kills
        P_SOFTDEP  0x10000000 stuck processing softdep worklist
        P_STOPPED  0x20000000 just stopped
        P_CPUPEG   0x40000000 do not move to another cpu

gid Effective group.

group
    Text name of effective group ID.

inblk
    Alias: inblock. Total blocks read.

jobc
    Job control count.

ktrace
    Tracing flags.

ktracep
    Tracing vnode.

lim The soft limit on memory used, specified via a call to setrlimit(2).

logname
    Alias: login. Login name of user who started the process.

lstart
    The exact time the command started, using the “%c” format described in strftime(3).

majflt
    Total page faults.

minflt
    Total page reclaims.

msgrcv
    Total messages received (reads from pipes/sockets).

msgsnd
    Total messages sent (writes on pipes/sockets).

nice
    Alias: ni. The process scheduling increment (see setpriority(2)).

nivcsw
    Total involuntary context switches.

nsigs
    Alias: nsignals. Total signals taken.

nswap
    Total swaps in/out.

nvcsw
    Total voluntary context switches.

nwchan
    Wait channel (as an address).

oublk
    Alias: oublock. Total blocks written.

p_ru
    Resource usage (valid only for zombie processes).

paddr
    Swap address.

pagein
    Pageins (same as majflt).

pgid
    Process group number.

pid Process ID.

ppid
    Parent process ID.

pri Scheduling priority.

re  Core residency time (in seconds; 127 = infinity).

rgid
    Real group ID.

rgroup
    Text name of real group ID.

rlink
    Reverse link on run queue, or 0.

rss The real memory (resident set) size of the process (in 1024 byte units).

rsz Alias: rssize. Resident set size + (text size / text use count).

ruid
    Real user ID.

ruser
    User name (from ruid).

sess
    Session pointer.

sig Alias: pending. Pending signals.

sigcatch
    Alias: caught. Caught signals.

sigignore
    Alias: ignored. Ignored signals.

sigmask
    Alias: blocked. Blocked signals.

sl  Sleep time (in seconds; 127 = infinity).

ssiz
    Stack size, in Kilobytes.

start
    Alias: etime. The time the command started. If the command started less than 24 hours ago, the start time is displayed using the “%l:%M%p” format described in strftime(3). If the command started less than 7 days ago, the start time is displayed using the “%a%I%p” format. Otherwise, the start time is displayed using the “%e%b%y” format.

state
    Alias: stat. The state is given by a sequence of letters, for example, “RWN”. The first letter indicates the run state of the process:

    D   Marks a process in disk (or other short term, uninterruptible) wait.
    I   Marks a process that is idle (sleeping for longer than about 20 seconds).
    R   Marks a runnable process.
    S   Marks a process that is sleeping for less than about 20 seconds.
    T   Marks a stopped process.
    Z   Marks a dead process (a “zombie”).

    Additional characters after these, if any, indicate additional state information:

    +   The process is in the foreground process group of its control terminal.
        The process has a raised CPU scheduling priority (see setpriority(2)).
        The process has specified a soft limit on memory requirements and is currently exceeding that limit; such a process is (necessarily) not swapped.
    E   The process is trying to exit.
    K   The process is a kernel thread.
    N   The process has a reduced CPU scheduling priority.
    s   The process is a session leader.
    V   The process is suspended during a vfork(2).
    X   The process is being traced or debugged.
    x   The process is being monitored by systrace(1).
    /n  On multiprocessor machines, specifies processor number n.

svgid
    Saved GID from a setgid executable.

svuid
    Saved UID from a setuid executable.

tdev
    Control terminal device number.

time
    Alias: cputime. Accumulated CPU time, user + system.

tpgid
    Control terminal process group ID.

tsess
    Control terminal session pointer.

tsiz
    Text size, in Kilobytes.

tt  An abbreviation for the pathname of the controlling terminal, if any. The abbreviation consists of the two letters following “/dev/tty”, or, for the console, “co”. This is followed by a ‘-’ if the process can no longer reach that controlling terminal (i.e. it has been revoked).

tty Full name of control terminal.

ucomm
    Alias: comm. Name to be used for accounting.

uid Effective user ID.

upr Alias: usrpri. Scheduling priority on return from system call.

user
    User name (from uid).

vsz Alias: vsize. Virtual size, in Kilobytes.

wchan
    The event (an address in the system) on which a process waits. When printed numerically, the initial part of the address is trimmed off and the result is printed in hex; for example, 0x80324000 prints as 324000.

xstat
    Exit or stop status (valid only for stopped or zombie process).

FILES
/dev
    special files and device names
/var/db/kvm_bsd.db
    system namelist database
/var/run/dev.db
    /dev name database

EXIT STATUS

EXAMPLES
Display information on all system processes:

    $ ps -auxw

SEE ALSO
fstat(1), kill(1), netstat(1), pgrep(1), pkill(1), procmap(1), systat(1), top(1), w(1), kvm(3), strftime(3), dev_mkdb(8), iostat(8), pstat(8), vmstat(8)

STANDARDS
The ps utility is compliant with the p1003.1-2008 specification.

The flags [-CchjkLMmNOrST] are extensions to that specification.

Behaviour for the -e flag differs between this implementation and p1003.1-2008.

HISTORY
A ps command appeared in AT&T UNIX in section 8 of the manual.

CAVEATS
When printing using the command keyword, a process that has exited and has a parent that has not yet waited for the process (in other words, a zombie) is listed as “<defunct>”, and a process which is blocked while trying to exit is listed as “<exiting>”. ps makes an educated guess as to the file name and arguments given when the process was created by examining memory or the swap area. The method is inherently somewhat unreliable and in any event a process is entitled to destroy this information, so the names cannot be depended on too much. The ucomm (accounting) keyword can, however, be depended on.

BUGS
Since ps cannot run faster than the system and is run as any other scheduled process, the information it displays can never be exact.